<?xml version="1.0" encoding="UTF-8"?>
<axsl:stylesheet xmlns:axsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
   <axsl:import href="verbid.xsl"/>
   <axsl:output method="html"/><!--
	This stylesheet was generated automatically from 'creatstyles.xsl'.
	Last modified unknown.
Copyright (C) 2004 Aziza Technology Associates, LLC Pittsburgh, PA 
 http://www.azizatech.com
 This program is free software; you can redistribute it and/or modify 
 it under the terms of the Mozilla Public License available at 
http://www.mozilla.org/MPL/

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 

	This stylesheet produces a version that can be used in a dynamic implementation. 
You can specify the values of the parameters at the commandline or through a parameter fed through a form to the XSLT processor.
$all = yes By default this will test against all guidelines (M, MA, Req, Opt, Rec). If  switched to 'no' only  those elements and attributes codified as M, MA and Req will be processed.

$sourcedoc is ignored in the dynamic version

This stylesheet was generated automatically from 'createbpgstyles.xsl' by  URL -->
   <axsl:param name="all">yes</axsl:param>
   <axsl:param name="doctitle">//eadheader//titleproper</axsl:param>
   <axsl:param name="sourcedoc">source.html</axsl:param>
   <axsl:template match="/">
      <html>
         <head>
            <title>Report for <axsl:value-of select="//eadheader//titleproper"/>
            </title>
            <style>
.appnotes {
position:absolute;
width:300px;
height:300px;
color:blue;
background-color:#FDF5E6;
text-align:center;
visibility:hidden;
z-index:10;
}
</style>
            <script language="JavaScript">
               <axsl:comment> 
//Begin
function getAppNotes(appnotes) {

msg=window.open("","msg","height=300,width=300,left=80,top=80 resizable=yes scrollbar=yes");
msg.document.write(document.getElementById(appnotes).innerHTML);
msg.document.close();
msg.focus();
   }
   function writeSource(sourcediv)
    {

     
      var title="Finding Aid Source Document";
      var doc=parent.targetArea1.document;      
      doc.open();
      doc.write("&lt;h3&gt;" + title + "&lt;/h3&gt;");

    
      doc.write(document.getElementById(sourcediv).innerHTML);
               doc.close();   
     //   top.targetArea1.location.href=  "#" + location; 
    }

 
//  End </axsl:comment>
            </script>
         </head>
         <body onload="writeSource('source')">
            <h4>Report for <axsl:value-of select="//eadheader//titleproper"/>
            </h4>
            <axsl:choose>
               <axsl:when test="$all='yes'">
                  <p>Reporting both Mandatory and Optional Guidelines</p>
               </axsl:when>
               <axsl:otherwise>
                  <p>Reporting Only Mandatory Guidelines</p>
               </axsl:otherwise>
            </axsl:choose>
	RLG Best Practice Guidelines for Encoded Archival Description
	<h2>Table 1 &lt;ead&gt;, &lt;eadheader&gt;, &lt;frontmatter&gt;</h2>
            <table border="1" width="100%" rules="all">
               <tbody>
                  <tr>
                     <th width="20%">Element Location</th>
                     <th width="15%">Attributes or Child Elements</th>
                     <th width="5%">Status</th>
                     <th width="40%">Application Notes</th>
                     <th width="20%">Possible Values</th>
                  </tr>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader">
                        <axsl:for-each select="ead/eadheader">
                           <axsl:choose>
                              <axsl:when test="@langencoding">
                                 <axsl:choose>
                                    <axsl:when test="@langencoding='iso639-2b'"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader
				 </td>
                                          <td>langencoding
= </td>
                                          <td>M
				 </td>
                                          <td>@langencoding is not set correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>'iso639-2b' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader
				 </td>
                                    <td>langencoding=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @langencoding<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>'iso639-2b' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@relatedencoding">
                                 <axsl:choose>
                                    <axsl:when test="@relatedencoding='MARC21'  or @relatedencoding='DC'  or @relatedencoding='Dublin Core' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader
				 </td>
                                          <td>relatedencoding=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e23">
                                                <h4>Application notes for ead/eadheader</h4>
                                                <p>Indicate a descriptive encoding system to which the &lt;eadheader&gt;
elements can be mapped. Since the intention of the &lt;eadheader&gt;
elements is to provide more robust and uniform discovery metadata,
Dublin Core may be the most appropriate system.</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e23')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>'MARC21'  or 'DC'  or 'Dublin Core' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader
				 </td>
                                    <td>relatedencoding=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @relatedencoding<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e23">
                                          <h4>Application notes for ead/eadheader</h4>
                                          <p>Indicate a descriptive encoding system to which the &lt;eadheader&gt;
elements can be mapped. Since the intention of the &lt;eadheader&gt;
elements is to provide more robust and uniform discovery metadata,
Dublin Core may be the most appropriate system.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e23')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>'MARC21'  or 'DC'  or 'Dublin Core' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@scriptencoding">
                                 <axsl:choose>
                                    <axsl:when test="@scriptencoding='iso15924'"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader
				 </td>
                                          <td>scriptencoding
= </td>
                                          <td>MA
				 </td>
                                          <td>@scriptencoding is not set correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>'iso15924' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader
				 </td>
                                    <td>scriptencoding=
					 </td>
                                    <td>MA
				 </td>
                                    <td> Missing @scriptencoding<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>'iso15924' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@repositoryencoding">
                                 <axsl:choose>
                                    <axsl:when test="@repositoryencoding='iso15511'"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader
				 </td>
                                          <td>repositoryencoding
= </td>
                                          <td>M
				 </td>
                                          <td>@repositoryencoding is not set correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>'iso15511' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader
				 </td>
                                    <td>repositoryencoding=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @repositoryencoding<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>'iso15511' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@countryencoding">
                                 <axsl:choose>
                                    <axsl:when test="@countryencoding='iso3166-1'"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader
				 </td>
                                          <td>countryencoding
= </td>
                                          <td>M
				 </td>
                                          <td>@countryencoding is not set correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>'iso3166-1' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader
				 </td>
                                    <td>countryencoding=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @countryencoding<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>'iso3166-1' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@dateencoding">
                                 <axsl:choose>
                                    <axsl:when test="@dateencoding='iso8601'"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader
				 </td>
                                          <td>dateencoding
= </td>
                                          <td>M
				 </td>
                                          <td>@dateencoding is not set correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>'iso8601' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader
				 </td>
                                    <td>dateencoding=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @dateencoding<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>'iso8601' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader
				 </td>
                           <td> </td>
                           <td>Req
				 </td>
                           <td>The element &lt; ead/eadheader
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/eadid">
                        <axsl:for-each select="ead/eadheader/eadid">
                           <axsl:choose>
                              <axsl:when test="@publicid or @identifier or @url"/>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/eadid
				 </td>
                                    <td> </td>
                                    <td>M
				 </td>
                                    <td>You must supply at least one of the attributes: publicid or identifier or url<div class="appnotes" id="app.d0e97">
                                          <h4>Application notes for ead/eadheader/eadid</h4>
                                          <p>The content of this element, together with its attributes, must
uniquely identify the EAD instance. The &lt;eadid&gt; should include at least one of the following attributes: publicid, identifier, url. See BPG for additional guidance. If using publicid, content is defined in ISO/IEC 9070:1991, intended to be universally
unique. If using identifier, content isa  machine-readable unique identifier. If using url, content should be expressed in absolute terms (e.g.,
http://www.loc.gov/ead/ms99999.xml).</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e97')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>n/a
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@countrycode">
                                 <axsl:choose>
                                    <axsl:when test="@countrycode[string-length()='2']"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/eadid
				 </td>
                                          <td>countrycode= </td>
                                          <td>M
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e80">
                                                <h4>Application notes for ead/eadheader/eadid</h4>
                                                <p>Use ISO 3166-1</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e80')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>Use  "iso3166-1" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/eadid
				 </td>
                                    <td>countrycode=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @countrycode<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e80">
                                          <h4>Application notes for ead/eadheader/eadid</h4>
                                          <p>Use ISO 3166-1</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e80')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td> Use "iso3166-1" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@mainagencycode"/>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/eadid
				 </td>
                                    <td>mainagencycode=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @mainagencycode<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e89">
                                          <h4>Application notes for ead/eadheader/eadid</h4>
                                          <p>Use a repository code supplied by the Library of Congress, the
National Library of Canada (MARC Code List for Organizations), the
Historical Manuscripts Commission in the United Kingdom
(ARCHON), other code assigned by OCLC, by RLG, or by a national
authority. The code should be formulated according to ISO 15511. If
no appropriate national authority exists, a unique identifier of the host
system must be developed using ISO 15511.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e89')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="/ead/eadheader/eadid/@url">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog">
                                       <axsl:choose>
                                          <axsl:when test="@encodinganalog='856$u'  or @encodinganalog='Identifier' "/>
                                          <axsl:otherwise>
                                             <tr>
                                                <td>ead/eadheader/eadid
				 </td>
                                                <td>encodinganalog=
									 </td>
                                                <td>MA
				 </td>
                                                <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>
                                                   <div class="appnotes" id="app.d0e118">
                                                      <h4>Application notes for ead/eadheader/eadid</h4>
                                                      <p>Use @encodinganalog when a URL exists.</p>
                                                   </div>
                                                   <br/>
                                                   <a onclick="getAppNotes('app.d0e118')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                                <td> For MARC21: '856$u' .
 For DC 'Identifier' . 
				 </td>
                                             </tr>
                                          </axsl:otherwise>
                                       </axsl:choose>
                                    </axsl:when>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/eadid
				 </td>
                                          <td>encodinganalog=
					 </td>
                                          <td>MA
				 </td>
                                          <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e118">
                                                <h4>Application notes for ead/eadheader/eadid</h4>
                                                <p>Use @encodinganalog when a URL exists.</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e118')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td> For MARC21: '856$u' .
 For DC 'Identifier' . 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise/>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader/eadid
				 </td>
                           <td> </td>
                           <td>Req
				 </td>
                           <td>The element &lt; ead/eadheader/eadid
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/filedesc/titlestmt/titleproper">
                        <axsl:for-each select="ead/eadheader/filedesc/titlestmt/titleproper">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='245$a'  or @encodinganalog='Title' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/filedesc/titlestmt/titleproper
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '245$a' .
 For DC 'Title' . 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/filedesc/titlestmt/titleproper
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '245$a' .
 For DC 'Title' . 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader/filedesc/titlestmt/titleproper
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/eadheader/filedesc/titlestmt/titleproper
&gt; does not appear in this document.<div class="appnotes" id="app.d0e134">
                                 <h4>Application notes for ead/eadheader/filedesc/titlestmt/titleproper</h4>
                                 <p>Use for the formal title of the finding aid itself and not the title of the fonds or record group being described.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e134')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/filedesc/titlestmt/author">
                        <axsl:for-each select="ead/eadheader/filedesc/titlestmt/author">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='245$c'  or @encodinganalog='Creator'  or @encodinganalog='Contributor' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/filedesc/titlestmt/author
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '245$c' .
 For DC 'Creator'  or 'Contributor' . 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/filedesc/titlestmt/author
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '245$c' .
 For DC 'Creator'  or 'Contributor' . 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader/filedesc/titlestmt/author
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td>The element &lt; ead/eadheader/filedesc/titlestmt/author
&gt; does not appear in this document.<div class="appnotes" id="app.d0e152">
                                 <h4>Application notes for ead/eadheader/filedesc/titlestmt/author</h4>
                                 <p>Record the name of the person or instituton responsible for the intellectual content of the encoded finding aid.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e152')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/filedesc/publicationstmt/publisher">
                        <axsl:for-each select="ead/eadheader/filedesc/publicationstmt/publisher">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='260$b'  or @encodinganalog='Publisher' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/filedesc/publicationstmt/publisher
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '260$b' .
 For DC 'Publisher' . 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/filedesc/publicationstmt/publisher
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '260$b' .
 For DC 'Publisher' . 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader/filedesc/publicationstmt/publisher
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/eadheader/filedesc/publicationstmt/publisher
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/filedesc/publicationstmt/date">
                        <axsl:for-each select="ead/eadheader/filedesc/publicationstmt/date">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='260$c'  or @encodinganalog='Date' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/filedesc/publicationstmt/date
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '260$c' .
 For DC 'Date' . 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/filedesc/publicationstmt/date
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '260$c' .
 For DC 'Date' . 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@normal">
                                 <axsl:choose>
                                    <axsl:when test="@normal[(number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-after(substring-after(., '-'), '-')) &lt; 31) &#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-before(substring-after(substring-after(., '-'), '-'), '/')) &lt; 31 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000 and number(substring-before(substring-after(substring-after(., '/'), '-'), '-')) &lt; 13 and number(substring-after(substring-after(substring-after(., '/'), '-'), '-')) &lt; 31)&#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-after(., '-')) &lt; 13)  or ( number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '/')) &lt; 13 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000) or  (number() &lt; 3000) or ( number(substring-before(., '/')) &lt; 3000 and number(substring-after(., '/')) &lt; 3000)]"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/filedesc/publicationstmt/date
				 </td>
                                          <td>normal= </td>
                                          <td>M
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>Use  "iso8601" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/filedesc/publicationstmt/date
				 </td>
                                    <td>normal=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @normal<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> Use "iso8601" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader/filedesc/publicationstmt/date
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/eadheader/filedesc/publicationstmt/date
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/filedesc/publicationstmt/address">
                        <axsl:for-each select="ead/eadheader/filedesc/publicationstmt/address"/>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/eadheader/filedesc/publicationstmt/address
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/eadheader/filedesc/publicationstmt/address
&gt; does not appear in this document.<div class="appnotes" id="app.d0e209">
                                    <h4>Application notes for ead/eadheader/filedesc/publicationstmt/address</h4>
                                    <p>System entities must be resolved in a union environment.</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e209')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/filedesc/notestmt">
                        <axsl:for-each select="ead/eadheader/filedesc/notestmt">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='500'  or @encodinganalog='653'  or @encodinganalog='Subject'  or @encodinganalog='Description' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/filedesc/notestmt
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '500'  or  '653' .
 For DC 'Subject'  or 'Description' . 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/filedesc/notestmt
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '500'  or  '653' .
 For DC 'Subject'  or 'Description' . 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/eadheader/filedesc/notestmt
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td> The repeatable element &lt;ead/eadheader/filedesc/notestmt
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e217">
                                    <h4>Application notes for ead/eadheader/filedesc/notestmt</h4>
                                    <p>May be used, per local conventions, for a variety of textual notes, especially to enrich available discovery metadata(see BPG p. 3)</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e217')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/profiledesc/creation">
                        <axsl:for-each select="ead/eadheader/profiledesc/creation">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='500' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/profiledesc/creation
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '500' .
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/profiledesc/creation
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '500' .
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader/profiledesc/creation
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/eadheader/profiledesc/creation
&gt; does not appear in this document.<div class="appnotes" id="app.d0e241">
                                 <h4>Application notes for ead/eadheader/profiledesc/creation</h4>
                                 <p>Statement recording facts about the encoding of the finding aid.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e241')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/profiledesc/date">
                        <axsl:for-each select="ead/eadheader/profiledesc/date">
                           <axsl:choose>
                              <axsl:when test="@normal">
                                 <axsl:choose>
                                    <axsl:when test="@normal[(number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-after(substring-after(., '-'), '-')) &lt; 31) &#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-before(substring-after(substring-after(., '-'), '-'), '/')) &lt; 31 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000 and number(substring-before(substring-after(substring-after(., '/'), '-'), '-')) &lt; 13 and number(substring-after(substring-after(substring-after(., '/'), '-'), '-')) &lt; 31)&#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-after(., '-')) &lt; 13)  or ( number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '/')) &lt; 13 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000) or  (number() &lt; 3000) or ( number(substring-before(., '/')) &lt; 3000 and number(substring-after(., '/')) &lt; 3000)]"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/profiledesc/date
				 </td>
                                          <td>normal= </td>
                                          <td>MA
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>Use  "iso8601" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/profiledesc/date
				 </td>
                                    <td>normal=
					 </td>
                                    <td>MA
				 </td>
                                    <td> Missing @normal<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> Use "iso8601" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/eadheader/profiledesc/date
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/eadheader/profiledesc/date
&gt; does not appear in this document.<div class="appnotes" id="app.d0e256">
                                    <h4>Application notes for ead/eadheader/profiledesc/date</h4>
                                    <p>Date of initial encoding into EAD</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e256')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/profiledesc/langusage/language">
                        <axsl:for-each select="ead/eadheader/profiledesc/langusage/language">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='546'  or @encodinganalog='Language' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/profiledesc/langusage/language
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '546' .
 For DC 'Language' . 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/profiledesc/langusage/language
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '546' .
 For DC 'Language' . 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@langcode">
                                 <axsl:choose>
                                    <axsl:when test="@langcode[string-length()='3']"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/profiledesc/langusage/language
				 </td>
                                          <td>langcode= </td>
                                          <td>M
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>Use  "iso639-2b" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/profiledesc/langusage/language
				 </td>
                                    <td>langcode=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @langcode<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> Use "iso639-2b" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@scriptcode">
                                 <axsl:choose>
                                    <axsl:when test="@scriptcode[string-length()='4']"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/profiledesc/langusage/language
				 </td>
                                          <td>scriptcode= </td>
                                          <td>MA
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>Use  "iso15924" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/profiledesc/langusage/language
				 </td>
                                    <td>scriptcode=
					 </td>
                                    <td>MA
				 </td>
                                    <td> Missing @scriptcode<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> Use "iso15924" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/eadheader/profiledesc/langusage/language
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/eadheader/profiledesc/langusage/language
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/profiledesc/descrules">
                        <axsl:for-each select="ead/eadheader/profiledesc/descrules">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.7.2 Rules for conventsions' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/eadheader/profiledesc/descrules
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td>
For ISAD(G)v2:'3.7.2 Rules for conventsions'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/eadheader/profiledesc/descrules
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td>
For ISAD(G)v2:'3.7.2 Rules for conventsions'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/eadheader/profiledesc/descrules
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td>The element &lt; ead/eadheader/profiledesc/descrules
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/revisiondesc/change">
                        <axsl:for-each select="ead/eadheader/revisiondesc/change">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='583' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/revisiondesc/change
				 </td>
                                          <td>encodinganalog=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                          <td> For MARC21: '583' .
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/eadheader/revisiondesc/change
				 </td>
                                    <td>encodinganalog=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> For MARC21: '583' .
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/eadheader/revisiondesc/change
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/eadheader/revisiondesc/change
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="/ead/eadheader/revisiondesc/change">
                        <axsl:choose>
                           <axsl:when test="/ead/eadheader/revisiondesc/change/item">
                              <axsl:for-each select="/ead/eadheader/revisiondesc/change/item"/>
                           </axsl:when>
                           <axsl:otherwise>
                              <axsl:if test="$all='yes'">
                                 <tr>
                                    <td>/ead/eadheader/revisiondesc/change/item
				 </td>
                                    <td> </td>
                                    <td>Rec
				 </td>
                                    <td> The repeatable element &lt;/ead/eadheader/revisiondesc/change/item
&gt; not been used in this document.
							

				 </td>
                                    <td> 
				</td>
                                 </tr>
                              </axsl:if>
                           </axsl:otherwise>
                        </axsl:choose>
                     </axsl:when>
                     <axsl:otherwise/>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/eadheader/revisiondesc/change">
                        <axsl:choose>
                           <axsl:when test="ead/eadheader/revisiondesc/change/date">
                              <axsl:for-each select="ead/eadheader/revisiondesc/change/date">
                                 <axsl:choose>
                                    <axsl:when test="@normal">
                                       <axsl:choose>
                                          <axsl:when test="@normal[(number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-after(substring-after(., '-'), '-')) &lt; 31) &#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-before(substring-after(substring-after(., '-'), '-'), '/')) &lt; 31 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000 and number(substring-before(substring-after(substring-after(., '/'), '-'), '-')) &lt; 13 and number(substring-after(substring-after(substring-after(., '/'), '-'), '-')) &lt; 31)&#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-after(., '-')) &lt; 13)  or ( number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '/')) &lt; 13 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000) or  (number() &lt; 3000) or ( number(substring-before(., '/')) &lt; 3000 and number(substring-after(., '/')) &lt; 3000)]"/>
                                          <axsl:otherwise>
                                             <tr>
                                                <td>ead/eadheader/revisiondesc/change/date
				 </td>
                                                <td>normal= </td>
                                                <td>M
				 </td>
                                                <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>
                                                   <div class="appnotes" id="app.d0e324">
                                                      <h4>Application notes for ead/eadheader/revisiondesc/change/date</h4>
                                                      <p>Use a normalized date according to iso8601.</p>
                                                   </div>
                                                   <br/>
                                                   <a onclick="getAppNotes('app.d0e324')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                                <td>Use  "iso8601" to format the attribute value.
				 </td>
                                             </tr>
                                          </axsl:otherwise>
                                       </axsl:choose>
                                    </axsl:when>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/eadheader/revisiondesc/change/date
				 </td>
                                          <td>normal=
					 </td>
                                          <td>M
				 </td>
                                          <td> Missing @normal<axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e324">
                                                <h4>Application notes for ead/eadheader/revisiondesc/change/date</h4>
                                                <p>Use a normalized date according to iso8601.</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e324')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td> Use "iso8601" to format attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:for-each>
                           </axsl:when>
                           <axsl:otherwise>
                              <axsl:if test="$all='yes'">
                                 <tr>
                                    <td>ead/eadheader/revisiondesc/change/date
				 </td>
                                    <td> </td>
                                    <td>Rec
				 </td>
                                    <td> The repeatable element &lt;ead/eadheader/revisiondesc/change/date
&gt; not been used in this document.
							

				 </td>
                                    <td> 
				</td>
                                 </tr>
                              </axsl:if>
                           </axsl:otherwise>
                        </axsl:choose>
                     </axsl:when>
                     <axsl:otherwise/>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/frontmatter">
                        <axsl:for-each select="ead/frontmatter"/>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/frontmatter
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td>The element &lt; ead/frontmatter
&gt; does not appear in this document.<div class="appnotes" id="app.d0e334">
                                    <h4>Application notes for ead/frontmatter</h4>
                                    <p>&lt;eadheader&gt; is preferred as the source for titlepage information in union environments. &lt;frontmatter&gt; is reserved for local applications.</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e334')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
               </tbody>
            </table>
	
            <h2>Table 2 &lt;archdesc&gt;</h2>
            <table border="1" width="100%" rules="all">
               <tbody>
                  <tr>
                     <th width="20%">Element Location</th>
                     <th width="15%">Attributes or Child Elements</th>
                     <th width="5%">Status</th>
                     <th width="40%">Application Notes</th>
                     <th width="20%">Possible Values</th>
                  </tr>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc">
                        <axsl:for-each select="ead/archdesc">
                           <axsl:choose>
                              <axsl:when test="@level">
                                 <axsl:choose>
                                    <axsl:when test="@level='collection'  or @level='recordgrp' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/archdesc
				 </td>
                                          <td>level=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e348">
                                                <h4>Application notes for ead/archdesc</h4>
                                                <p>Most commonly set as fonds(use collection or recordgroup as applicable). This element is
considered an essential element for data
exchange by ISAD(G)v2.</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e348')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>'collection'  or 'recordgrp' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc
				 </td>
                                    <td>level=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @level<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e348">
                                          <h4>Application notes for ead/archdesc</h4>
                                          <p>Most commonly set as fonds(use collection or recordgroup as applicable). This element is
considered an essential element for data
exchange by ISAD(G)v2.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e348')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>'collection'  or 'recordgrp' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@relatedencoding">
                                 <axsl:choose>
                                    <axsl:when test="@relatedencoding='MARC21'  or @relatedencoding='DC'  or @relatedencoding='Dublin Core'  or @relatedencoding='ISAD(G)v2' "/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/archdesc
				 </td>
                                          <td>relatedencoding=
									 </td>
                                          <td>M
				 </td>
                                          <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e363">
                                                <h4>Application notes for ead/archdesc</h4>
                                                <p>Indicate descriptive encoding system to which
the &lt;archdesc&gt; elements can be mapped. Since
&lt;archdesc&gt; elements describe the archival
materials, MARC 21 or ISAD(G)v2 may be the
most appropriate system.</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e363')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>'MARC21'  or 'DC'  or 'Dublin Core'  or 'ISAD(G)v2' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc
				 </td>
                                    <td>relatedencoding=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @relatedencoding<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e363">
                                          <h4>Application notes for ead/archdesc</h4>
                                          <p>Indicate descriptive encoding system to which
the &lt;archdesc&gt; elements can be mapped. Since
&lt;archdesc&gt; elements describe the archival
materials, MARC 21 or ISAD(G)v2 may be the
most appropriate system.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e363')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>'MARC21'  or 'DC'  or 'Dublin Core'  or 'ISAD(G)v2' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@type"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc
				 </td>
                                       <td>type=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @type<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/origination">
                        <axsl:for-each select="ead/archdesc/did/origination">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.1'  or @encodinganalog='100'  or @encodinganalog='110'  or @encodinganalog='111'  or @encodinganalog='Creator' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/origination
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '100'  or  '110'  or  '111' .
 For DC 'Creator' . 
For ISAD(G)v2:'3.2.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/origination
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '100'  or  '110'  or  '111' .
 For DC 'Creator' . 
For ISAD(G)v2:'3.2.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="persname|corpname|famname|name"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/origination
				 </td>
                                       <td>
&lt;persname&gt;
 or 
&lt;corpname&gt;
 or 
&lt;famname&gt;
 or 
&lt;name&gt;
 </td>
                                       <td>Rec
				 </td>
                                       <td>At least one child element should be supplied. 

<axsl:call-template name="getcontext"/>
                                          <div class="appnotes" id="app.d0e392">
                                             <h4>Application notes for ead/archdesc/did/origination</h4>
                                             <p>Use appropriate name tag to indicate the type of
origination name.</p>
                                          </div>
                                          <br/>
                                          <a onclick="getAppNotes('app.d0e392')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                       <td>
&lt;persname&gt;
 or 
&lt;corpname&gt;
 or 
&lt;famname&gt;
 or 
&lt;name&gt;
 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/did/origination
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc/did/origination
&gt; does not appear in this document.<div class="appnotes" id="app.d0e390">
                                 <h4>Application notes for ead/archdesc/did/origination</h4>
                                 <p>This element is considered an essential element
for data exchange by ISAD(G)v2.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e390')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/unittitle">
                        <axsl:for-each select="ead/archdesc/did/unittitle">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.2'  or @encodinganalog='245$a'  or @encodinganalog='Title' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/unittitle
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '245$a' .
 For DC 'Title' . 
For ISAD(G)v2:'3.2.2'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/unittitle
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '245$a' .
 For DC 'Title' . 
For ISAD(G)v2:'3.2.2'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/did/unittitle
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc/did/unittitle
&gt; does not appear in this document.<div class="appnotes" id="app.d0e435">
                                 <h4>Application notes for ead/archdesc/did/unittitle</h4>
                                 <p>This element is considered an essential element
for data exchange by ISAD(G)v2.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e435')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/unitdate">
                        <axsl:for-each select="ead/archdesc/did/unitdate">
                           <axsl:choose>
                              <axsl:when test="@type"/>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc/did/unitdate
				 </td>
                                    <td>type=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @type<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@normal">
                                 <axsl:choose>
                                    <axsl:when test="@normal[(number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-after(substring-after(., '-'), '-')) &lt; 31) &#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-before(substring-after(substring-after(., '-'), '-'), '/')) &lt; 31 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000 and number(substring-before(substring-after(substring-after(., '/'), '-'), '-')) &lt; 13 and number(substring-after(substring-after(substring-after(., '/'), '-'), '-')) &lt; 31)&#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-after(., '-')) &lt; 13)  or ( number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '/')) &lt; 13 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000) or  (number() &lt; 3000) or ( number(substring-before(., '/')) &lt; 3000 and number(substring-after(., '/')) &lt; 3000)]"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/archdesc/did/unitdate
				 </td>
                                          <td>normal= </td>
                                          <td>M
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e463">
                                                <h4>Application notes for ead/archdesc/did/unitdate</h4>
                                                <p>Use ISO 8601 to normalize dates to the extent they are known (see BPG p3-4)</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e463')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>Use  "iso8601" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc/did/unitdate
				 </td>
                                    <td>normal=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @normal<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e463">
                                          <h4>Application notes for ead/archdesc/did/unitdate</h4>
                                          <p>Use ISO 8601 to normalize dates to the extent they are known (see BPG p3-4)</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e463')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td> Use "iso8601" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.3'  or @encodinganalog='245$f'  or @encodinganalog='245$g'  or @encodinganalog='260$c'  or @encodinganalog='Coverage'  or @encodinganalog='Date' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/unitdate
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>
                                                <div class="appnotes" id="app.d0e472">
                                                   <h4>Application notes for ead/archdesc/did/unitdate</h4>
                                                   <p>Use 245$f (inclusive or single) or 245$g (bulk) if materials are manuscripts(MARC "u" format) If materials are other than archives and personal paper collections use 260$c (MARC "g" format)</p>
                                                </div>
                                                <br/>
                                                <a onclick="getAppNotes('app.d0e472')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                             <td> For MARC21: '245$f'  or  '245$g'  or  '260$c' .
 For DC 'Coverage'  or 'Date' . 
For ISAD(G)v2:'3.2.3'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/unitdate
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>
                                          <div class="appnotes" id="app.d0e472">
                                             <h4>Application notes for ead/archdesc/did/unitdate</h4>
                                             <p>Use 245$f (inclusive or single) or 245$g (bulk) if materials are manuscripts(MARC "u" format) If materials are other than archives and personal paper collections use 260$c (MARC "g" format)</p>
                                          </div>
                                          <br/>
                                          <a onclick="getAppNotes('app.d0e472')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                       <td> For MARC21: '245$f'  or  '245$g'  or  '260$c' .
 For DC 'Coverage'  or 'Date' . 
For ISAD(G)v2:'3.2.3'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="../@encodinganalog='3.1.3'">
                                 <axsl:choose>
                                    <axsl:when test="@datechar"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/archdesc/did/unitdate
				 </td>
                                          <td>datechar=
					 </td>
                                          <td>MA
				 </td>
                                          <td> Missing @datechar<axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e499">
                                                <h4>Application notes for ead/archdesc/did/unitdate</h4>
                                                <p>Set values to indicate whether dates given are of creation or accumulation when ISAD(G)v2 encodinganalog is set to 3.1.3</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e499')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise/>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/did/unitdate
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc/did/unitdate
&gt; does not appear in this document.<div class="appnotes" id="app.d0e456">
                                 <h4>Application notes for ead/archdesc/did/unitdate</h4>
                                 <p>US repositories following APPM practice
normally include &lt;unitdate&gt; as part of
&lt;unittitle&gt;, whereas British and Canadian
practice, following ISAD(G)v2 use &lt;unitdate&gt; at
the same level as &lt;unittitle&gt;. Given the
likelihood of further international standardization,
separate title and date is preferred but both
practices are permitted. Repeat &lt;unitdate&gt; if
both inclusive and bulk dates are given. This
element is considered an essential element for
data exchange by ISAD(G)v2.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e456')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/physdesc/extent">
                        <axsl:for-each select="ead/archdesc/did/physdesc/extent">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.1.5'  or @encodinganalog='300' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/physdesc/extent
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '300' .
For ISAD(G)v2:'3.1.5'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/physdesc/extent
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '300' .
For ISAD(G)v2:'3.1.5'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/did/physdesc/extent
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td> The repeatable element &lt;ead/archdesc/did/physdesc/extent
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e511">
                                 <h4>Application notes for ead/archdesc/did/physdesc/extent</h4>
                                 <p>Use multiple &lt;extent &gt; tage for multiple views, items, linear feet, etc. Units of measure should be epxressed either as part of the content of this tag or in a unit attribute. This element is considered an essential element for data exchange by ISAD(G)v2.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e511')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/abstract">
                        <axsl:for-each select="ead/archdesc/did/abstract">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='Description'  or @encodinganalog='520' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/abstract
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '520' .
For ISAD(G)v2:'Description'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/abstract
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '520' .
For ISAD(G)v2:'Description'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc/did/abstract
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc/did/abstract
&gt; does not appear in this document.<div class="appnotes" id="app.d0e529">
                                    <h4>Application notes for ead/archdesc/did/abstract</h4>
                                    <p>Use for a brief summary of collection contents at the highest level, in addition to &lt;scopecontent&gt; for a fuller discussion.  At component level, use
&lt;scopecontent&gt; rather than &lt;abstract&gt;.</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e529')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/physloc">
                        <axsl:for-each select="ead/archdesc/did/physloc">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='090'  or @encodinganalog='852$z' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/physloc
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '090'  or  '852$z' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/physloc
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '090'  or  '852$z' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc/did/physloc
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td>The element &lt; ead/archdesc/did/physloc
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/repository">
                        <axsl:for-each select="ead/archdesc/did/repository">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='Publisher'  or @encodinganalog='852' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/repository
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '852' .
 For DC 'Publisher' .  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/repository
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '852' .
 For DC 'Publisher' .  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/did/repository
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc/did/repository
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="/ead/archdesc/did/repository">
                        <axsl:choose>
                           <axsl:when test="ead/archdesc/did/repository/corpname|ead/archdesc/did/repository/name">
                              <axsl:for-each select="ead/archdesc/did/repository/corpname|ead/archdesc/did/repository/name"/>
                           </axsl:when>
                           <axsl:otherwise>
                              <axsl:if test="$all='yes'">
                                 <tr>
                                    <td> archdesc repository corpname or name
				 </td>
                                    <td> </td>
                                    <td>Rec
				 </td>
                                    <td> The repeatable element &lt; archdesc repository corpname or name
&gt; not been used in this document.
							

				 </td>
                                    <td> 
				</td>
                                 </tr>
                              </axsl:if>
                           </axsl:otherwise>
                        </axsl:choose>
                     </axsl:when>
                     <axsl:otherwise/>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/unitid">
                        <axsl:for-each select="ead/archdesc/did/unitid">
                           <axsl:choose>
                              <axsl:when test="@countrycode">
                                 <axsl:choose>
                                    <axsl:when test="@countrycode[string-length()='2']"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/archdesc/did/unitid
				 </td>
                                          <td>countrycode= </td>
                                          <td>M
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e582">
                                                <h4>Application notes for ead/archdesc/did/unitid</h4>
                                                <p>Use ISO 3166-1</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e582')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>Use  "iso3166-1" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc/did/unitid
				 </td>
                                    <td>countrycode=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @countrycode<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e582">
                                          <h4>Application notes for ead/archdesc/did/unitid</h4>
                                          <p>Use ISO 3166-1</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e582')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td> Use "iso3166-1" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@repositorycode"/>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc/did/unitid
				 </td>
                                    <td>repositorycode=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @repositorycode<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e591">
                                          <h4>Application notes for ead/archdesc/did/unitid</h4>
                                          <p>Use ISO 15511</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e591')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/did/unitid
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc/did/unitid
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/langmaterial/language">
                        <axsl:for-each select="ead/archdesc/did/langmaterial/language">
                           <axsl:choose>
                              <axsl:when test="@langcode">
                                 <axsl:choose>
                                    <axsl:when test="@langcode[string-length()='3']"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/archdesc/did/langmaterial/language
				 </td>
                                          <td>langcode= </td>
                                          <td>M
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>

				 </td>
                                          <td>Use  "iso639-2b" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc/did/langmaterial/language
				 </td>
                                    <td>langcode=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @langcode<axsl:call-template name="getcontext"/>

				 </td>
                                    <td> Use "iso639-2b" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/did/langmaterial/language
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc/did/langmaterial/language
&gt; does not appear in this document.<div class="appnotes" id="app.d0e600">
                                 <h4>Application notes for ead/archdesc/did/langmaterial/language</h4>
                                 <p/>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e600')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/did/note">
                        <axsl:for-each select="ead/archdesc/did/note">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='500' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/did/note
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '500' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/did/note
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '500' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc/did/note
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td> The repeatable element &lt;ead/archdesc/did/note
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e611">
                                    <h4>Application notes for ead/archdesc/did/note</h4>
                                    <p>This element is considered an essential element for data exchange by ISAD(G)v2.</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e611')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//bioghist[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//bioghist[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.2'  or @encodinganalog='545' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//bioghist
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '545' .
For ISAD(G)v2:'3.2.2'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//bioghist
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '545' .
For ISAD(G)v2:'3.2.2'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc//bioghist
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc//bioghist
&gt; does not appear in this document.

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//scopecontent[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//scopecontent[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.3.1'  or @encodinganalog='520'  or @encodinganalog='Description' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//scopecontent
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '520' .
 For DC 'Description' . 
For ISAD(G)v2:'3.3.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//scopecontent
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '520' .
 For DC 'Description' . 
For ISAD(G)v2:'3.3.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc//scopecontent
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc//scopecontent
&gt; does not appear in this document.<div class="appnotes" id="app.d0e643">
                                 <h4>Application notes for ead/archdesc//scopecontent</h4>
                                 <p>If organization/arrangement can not readily be separated from scope note  give as part of &lt;scopecontent&gt;. If separable use &lt;arrangement&gt; and do not nest in &lt;scopecontent&gt;</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e643')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//arrangement[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//arrangement[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.3.4'  or @encodinganalog='351' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//arrangement
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '351' .
For ISAD(G)v2:'3.3.4'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//arrangement
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '351' .
For ISAD(G)v2:'3.3.4'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//arrangement
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//arrangement
&gt; does not appear in this document.<div class="appnotes" id="app.d0e664">
                                    <h4>Application notes for ead/archdesc//arrangement</h4>
                                    <p>Use to encode the filing sequence of the
material (e.g., alphabetical or chronological)
and/or the manner in which the collection has
been ordered (e.g., organized into series).</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e664')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]"/>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//controlaccess
&gt; does not appear in this document.<div class="appnotes" id="app.d0e682">
                                    <h4>Application notes for ead/archdesc//controlaccess</h4>
                                    <p>Subelements are repeatable and should be
used if applicable.</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e682')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//corpname">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//corpname">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='110'  or @encodinganalog='111'  or @encodinganalog='610'  or @encodinganalog='611'  or @encodinganalog='710'  or @encodinganalog='711' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//corpname
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '110'  or  '111'  or  '610'  or  '611'  or  '710'  or  '711' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//corpname
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '110'  or  '111'  or  '610'  or  '611'  or  '710'  or  '711' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//corpname
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//corpname
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//corpname
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//corpname
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//persname">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//persname">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='100'  or @encodinganalog='600'  or @encodinganalog='700' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//persname
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '100'  or  '600'  or  '700' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//persname
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '100'  or  '600'  or  '700' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//persname
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//persname
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//persname
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//persname
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//geogname">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//geogname">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='651' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//geogname
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '651' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//geogname
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '651' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//geogname
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//geogname
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//geogname
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//geogname
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//famname">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//famname">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='100'  or @encodinganalog='600' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//famname
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '100'  or  '600' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//famname
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '100'  or  '600' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//famname
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//famname
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//famname
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//famname
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//subject">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//subject">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='650'  or @encodinganalog='Subject' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//subject
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '650' .
For ISAD(G)v2:'Subject'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//subject
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '650' .
For ISAD(G)v2:'Subject'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//subject
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//subject
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//subject
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//subject
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//genreform">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//genreform">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='655' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//genreform
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '655' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//genreform
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '655' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//genreform
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//genreform
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//genreform
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//genreform
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//occupation">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//occupation">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='656' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//occupation
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '656' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//occupation
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '656' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//occupation
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//occupation
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//occupation
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//occupation
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//function">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//function">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='657' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//function
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '657' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//function
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '657' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//function
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//function
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//function
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//function
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//controlaccess[not(ancestor::dsc)]//title">
                        <axsl:for-each select="ead/archdesc//controlaccess[not(ancestor::dsc)]//title">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='130'  or @encodinganalog='630'  or @encodinganalog='730' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//controlaccess//title
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '130'  or  '630'  or  '730' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//title
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '130'  or  '630'  or  '730' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@source"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//title
				 </td>
                                       <td>source=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @source<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@rules"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//controlaccess//title
				 </td>
                                       <td>rules=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @rules<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//controlaccess//title
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//controlaccess//title
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//accessrestrict[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//accessrestrict[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.4.1'  or @encodinganalog='506' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//accessrestrict
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '506' .
For ISAD(G)v2:'3.4.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//accessrestrict
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '506' .
For ISAD(G)v2:'3.4.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc//accessrestrict
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td>The element &lt; ead/archdesc//accessrestrict
&gt; does not appear in this document.<div class="appnotes" id="app.d0e919">
                                 <h4>Application notes for ead/archdesc//accessrestrict</h4>
                                 <p>Use for conditions governing access.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e919')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//accruals[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//accruals[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.3.3'  or @encodinganalog='584' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc/accruals
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '584' .
For ISAD(G)v2:'3.3.3'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc/accruals
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '584' .
For ISAD(G)v2:'3.3.3'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc/accruals
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc/accruals
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//acqinfo[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//acqinfo[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.4'  or @encodinganalog='584' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//acqinfo
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '584' .
For ISAD(G)v2:'3.2.4'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//acqinfo
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '584' .
For ISAD(G)v2:'3.2.4'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//acqinfo
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//acqinfo
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//altformavail[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//altformavail[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.5.2'  or @encodinganalog='530' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//altformavail
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '530' .
For ISAD(G)v2:'3.5.2'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//altformavail
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '530' .
For ISAD(G)v2:'3.5.2'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//altformavail
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//altformavail
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//appraisal[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//appraisal[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.3.2'  or @encodinganalog='583$a' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//appraisal
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '583$a' .
For ISAD(G)v2:'3.3.2'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//appraisal
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '583$a' .
For ISAD(G)v2:'3.3.2'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//appraisal
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//appraisal
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//custodhist[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//custodhist[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.3'  or @encodinganalog='561' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//custodhist
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '561' .
For ISAD(G)v2:'3.2.3'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//custodhist
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '561' .
For ISAD(G)v2:'3.2.3'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//custodhist
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//custodhist
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//prefercite[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//prefercite[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='524' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//prefercite
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '524' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//prefercite
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '524' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//prefercite
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//prefercite
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//processinfo[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//processinfo[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='583'  or @encodinganalog='500' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//processinfo
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '583'  or  '500' . 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//processinfo
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '583'  or  '500' . 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//processinfo
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//processinfo
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//userestrict[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//userestrict[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.4.2'  or @encodinganalog='540' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//userestrict
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>
                                                <div class="appnotes" id="app.d0e1041">
                                                   <h4>Application notes for ead/archdesc//userestrict</h4>
                                                   <p>Use for conditions governing use.</p>
                                                </div>
                                                <br/>
                                                <a onclick="getAppNotes('app.d0e1041')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                             <td> For MARC21: '540' .
For ISAD(G)v2:'3.4.2'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//userestrict
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>
                                          <div class="appnotes" id="app.d0e1041">
                                             <h4>Application notes for ead/archdesc//userestrict</h4>
                                             <p>Use for conditions governing use.</p>
                                          </div>
                                          <br/>
                                          <a onclick="getAppNotes('app.d0e1041')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                       <td> For MARC21: '540' .
For ISAD(G)v2:'3.4.2'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//userestrict
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//userestrict
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//relatedmaterial[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//relatedmaterial[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.5.3'  or @encodinganalog='544 1' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//relatedmaterial
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '544 1' .
For ISAD(G)v2:'3.5.3'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//relatedmaterial
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '544 1' .
For ISAD(G)v2:'3.5.3'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//relatedmaterial
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//relatedmaterial
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//separatedmaterial[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//separatedmaterial[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.5.3'  or @encodinganalog='544 0' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//separatedmaterial
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '544 0' .
For ISAD(G)v2:'3.5.3'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//separatedmaterial
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '544 0' .
For ISAD(G)v2:'3.5.3'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//separatedmaterial
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td>The element &lt; ead/archdesc//separatedmaterial
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//otherfindaid[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//otherfindaid[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.4.5'  or @encodinganalog='555' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//otherfindaid
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '555' .
For ISAD(G)v2:'3.4.5'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//otherfindaid
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '555' .
For ISAD(G)v2:'3.4.5'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//otherfindaid
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td>The element &lt; ead/archdesc//otherfindaid
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//bibliography[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//bibliography[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.5.4' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//bibliography
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td>
For ISAD(G)v2:'3.5.4'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//bibliography
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td>
For ISAD(G)v2:'3.5.4'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//bibliography
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td>The element &lt; ead/archdesc//bibliography
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//odd[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//odd[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.6.1'  or @encodinganalog='500' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//odd
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '500' .
For ISAD(G)v2:'3.6.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//odd
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '500' .
For ISAD(G)v2:'3.6.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//odd
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td>The element &lt; ead/archdesc//odd
&gt; does not appear in this document.

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//originalsloc[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//originalsloc[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.5.1'  or @encodinganalog='355' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//originalsloc
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '355' .
For ISAD(G)v2:'3.5.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//originalsloc
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '355' .
For ISAD(G)v2:'3.5.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//originalsloc
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//originalsloc
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//phystech[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//phystech[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.4.4'  or @encodinganalog='340'  or @encodinganalog='538' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//phystech
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '340'  or  '538' .
For ISAD(G)v2:'3.4.4'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//phystech
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '340'  or  '538' .
For ISAD(G)v2:'3.4.4'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>ead/archdesc//phystech
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td> The repeatable element &lt;ead/archdesc//phystech
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
               </tbody>
            </table>
	
            <h2>Table 3 &lt;dsc&gt;</h2>
            <table border="1" width="100%" rules="all">
               <tbody>
                  <tr>
                     <th width="20%">Element Location</th>
                     <th width="15%">Attributes or Child Elements</th>
                     <th width="5%">Status</th>
                     <th width="40%">Application Notes</th>
                     <th width="20%">Possible Values</th>
                  </tr>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/dsc">
                        <axsl:for-each select="ead/archdesc/dsc">
                           <axsl:choose>
                              <axsl:when test="@type">
                                 <axsl:choose>
                                    <axsl:when test="@type='combined'"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>ead/archdesc/dsc
				 </td>
                                          <td>type
= </td>
                                          <td>Req
				 </td>
                                          <td>@type is not set correctly <axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e1170">
                                                <h4>Application notes for ead/archdesc/dsc</h4>
                                                <p>Type="combined" recormmended (description and detailed listing of components combined in a singe &lt;dsc&gt;</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e1170')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>'combined' 
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>ead/archdesc/dsc
				 </td>
                                    <td>type=
					 </td>
                                    <td>Req
				 </td>
                                    <td> Missing @type<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e1170">
                                          <h4>Application notes for ead/archdesc/dsc</h4>
                                          <p>Type="combined" recormmended (description and detailed listing of components combined in a singe &lt;dsc&gt;</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1170')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>'combined' 
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc/dsc
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td> The repeatable element &lt;ead/archdesc/dsc
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1168">
                                 <h4>Application notes for ead/archdesc/dsc</h4>
                                 <p>Single &lt;dsc&gt; model should be used with nested
components in which descriptions for subfonds, series,
subseries, file, and item are placed at the appropriate level
in the component hierarchy.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1168')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="//c01|//c02|//c03|//c04|//c05|//c06|//c07|//c08|//c09|//c10|//c11|//c12|//c">
                        <axsl:for-each select="//c01|//c02|//c03|//c04|//c05|//c06|//c07|//c08|//c09|//c10|//c11|//c12|//c">
                           <axsl:choose>
                              <axsl:when test="@level"/>
                              <axsl:otherwise>
                                 <tr>
                                    <td>c/c0x
				 </td>
                                    <td>level=
					 </td>
                                    <td>Req
				 </td>
                                    <td> Missing @level<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e1188">
                                          <h4>Application notes for c/c0x</h4>
                                          <p>The levels of the components should be subordinate to the
level set for in &lt;archdesc&gt; (see BPG "Archival Levels," page 6).
This element is considered an essential element for data
exchange by ISAD(G)v2.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1188')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>c/c0x
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td> The repeatable element &lt;c/c0x
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1186">
                                 <h4>Application notes for c/c0x</h4>
                                 <p>Numbered and unnumbered components are functionally
equivalent. Use of the numbered components may provide
a more readily intelligible view of the nested structure to the
human eye and may make machine manipulation easier.
Only one of the options can be used in a given &lt;dsc&gt;.
Institutions are urged to adopt one model or the other as
standard practice. Nested &lt;c&gt;/&lt;c0x&gt;s should be used as
needed to reflect the intellectual structure of the archival
materials. The full suite of subelements and attributes
described are available at each component level.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1186')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="//dsc//did">
                        <axsl:for-each select="//dsc//did">
                           <axsl:choose>
                              <axsl:when test="unittitle"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>c/c0x did
				 </td>
                                    <td>
&lt;unittitle&gt;
 </td>
                                    <td>M
				 </td>
                                    <td>All child elements must be supplied. 


<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>
&lt;unittitle&gt;

				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="unitid  and origination  and langmaterial/language"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>c/c0x did
				 </td>
                                    <td>
&lt;unitid&gt;
 or 
&lt;origination&gt;
 or 
&lt;langmaterial/language&gt;
 </td>
                                    <td>MA
				 </td>
                                    <td>Include these child elements as applicable. 
						
<axsl:call-template name="getcontext"/>

				 </td>
                                    <td>
&lt;unitid&gt;
 and 
&lt;origination&gt;
 and 
&lt;langmaterial/language&gt;

				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="unitdate  and physdesc/extent"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>c/c0x did
				 </td>
                                       <td>
&lt;unitdate&gt;
 or 
&lt;physdesc/extent&gt;
 </td>
                                       <td>Rec
				 </td>
                                       <td>Include these child elements as applicable. 
						
<axsl:call-template name="getcontext"/>

				 </td>
                                       <td>
&lt;unitdate&gt;
 and 
&lt;physdesc/extent&gt;
 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>c/c0x did
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td> The repeatable element &lt;c/c0x did
&gt; not been used in this document.
							

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/dsc//did/origination">
                        <axsl:for-each select="ead/archdesc/dsc//did/origination">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.1'  or @encodinganalog='100'  or @encodinganalog='110'  or @encodinganalog='111'  or @encodinganalog='Creator' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>c/c0x did/origination
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '100'  or  '110'  or  '111' .
 For DC 'Creator' . 
For ISAD(G)v2:'3.2.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>c/c0x did/origination
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '100'  or  '110'  or  '111' .
 For DC 'Creator' . 
For ISAD(G)v2:'3.2.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="persname|corpname|famname|name"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>c/c0x did/origination
				 </td>
                                       <td>
&lt;persname&gt;
 or 
&lt;corpname&gt;
 or 
&lt;famname&gt;
 or 
&lt;name&gt;
 </td>
                                       <td>Rec
				 </td>
                                       <td>At least one child element should be supplied. 

<axsl:call-template name="getcontext"/>
                                          <div class="appnotes" id="app.d0e1232">
                                             <h4>Application notes for c/c0x did/origination</h4>
                                             <p>Use appropriate name tag to indicate the type of originations name.</p>
                                          </div>
                                          <br/>
                                          <a onclick="getAppNotes('app.d0e1232')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                       <td>
&lt;persname&gt;
 or 
&lt;corpname&gt;
 or 
&lt;famname&gt;
 or 
&lt;name&gt;
 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>c/c0x did/origination
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td> The repeatable element &lt;c/c0x did/origination
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1230">
                                 <h4>Application notes for c/c0x did/origination</h4>
                                 <p>Mandatory if creator at level being described is different than defined at the &lt;archdesc&gt; or in a parent level. This element is considered an essential element for data exchange by ISAD(G)v2.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1230')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/dsc//unitid">
                        <axsl:for-each select="ead/archdesc/dsc//unitid">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.1.1'  or @encodinganalog='050'  or @encodinganalog='090'  or @encodinganalog='099'  or @encodinganalog='Identifier' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>component unitids
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '050'  or  '090'  or  '099' .
 For DC 'Identifier' . 
For ISAD(G)v2:'3.1.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>component unitids
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '050'  or  '090'  or  '099' .
 For DC 'Identifier' . 
For ISAD(G)v2:'3.1.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@countrycode">
                                 <axsl:choose>
                                    <axsl:when test="@countrycode[string-length()='2']"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>component unitids
				 </td>
                                          <td>countrycode= </td>
                                          <td>MA
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e1298">
                                                <h4>Application notes for component unitids</h4>
                                                <p>Use ISO 3166-1</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e1298')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>Use  "iso3166-1" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>component unitids
				 </td>
                                    <td>countrycode=
					 </td>
                                    <td>MA
				 </td>
                                    <td> Missing @countrycode<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e1298">
                                          <h4>Application notes for component unitids</h4>
                                          <p>Use ISO 3166-1</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1298')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td> Use "iso3166-1" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@repositorycode"/>
                              <axsl:otherwise>
                                 <tr>
                                    <td>component unitids
				 </td>
                                    <td>repositorycode=
					 </td>
                                    <td>MA
				 </td>
                                    <td> Missing @repositorycode<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e1307">
                                          <h4>Application notes for component unitids</h4>
                                          <p>Use ISO 15511</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1307')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>component unitids
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td> The repeatable element &lt;component unitids
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1275">
                                 <h4>Application notes for component unitids</h4>
                                 <p>All units of a description should be given a unique identifier.
While optional, it is recommended that, if a unique
identifying number or filing code is present, it should be
encoded as &lt;unitid&gt; rather than &lt;container&gt; or &lt;unittitle&gt;.
This element is considered an essential element for data
exchange by ISAD(G)v2.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1275')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="@level='subfonds' or @level='subgroup' or @level='series'">
                        <axsl:choose>
                           <axsl:when test="ead/archdesc/dsc//did/unittitle">
                              <axsl:for-each select="ead/archdesc/dsc//did/unittitle">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog">
                                       <axsl:choose>
                                          <axsl:when test="@encodinganalog='3.2.2'  or @encodinganalog='245$a'  or @encodinganalog='Title' "/>
                                          <axsl:otherwise>
                                             <axsl:if test="$all='yes'">
                                                <tr>
                                                   <td>component unittitle
				 </td>
                                                   <td>encodinganalog=
									 </td>
                                                   <td>Rec
				 </td>
                                                   <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                                   <td> For MARC21: '245$a' .
 For DC 'Title' . 
For ISAD(G)v2:'3.2.2'  
				</td>
                                                </tr>
                                             </axsl:if>
                                          </axsl:otherwise>
                                       </axsl:choose>
                                    </axsl:when>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>component unittitle
				 </td>
                                             <td>encodinganalog=
					 </td>
                                             <td>Rec
				 </td>
                                             <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '245$a' .
 For DC 'Title' . 
For ISAD(G)v2:'3.2.2'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:for-each>
                           </axsl:when>
                           <axsl:otherwise>
                              <axsl:if test="$all='yes'">
                                 <tr>
                                    <td>component unittitle
				 </td>
                                    <td> </td>
                                    <td>Rec
				 </td>
                                    <td> The repeatable element &lt;component unittitle
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1319">
                                          <h4>Application notes for component unittitle</h4>
                                          <p>Considered the minimum for description at component levels because some description is needed for users to decide if documents are worthy of further investigation. This element is considered an essential element for data exchange by ISAD(G)v2.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1319')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td> 
				</td>
                                 </tr>
                              </axsl:if>
                           </axsl:otherwise>
                        </axsl:choose>
                     </axsl:when>
                     <axsl:otherwise/>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="//dsc//unitdate">
                        <axsl:for-each select="//dsc//unitdate">
                           <axsl:choose>
                              <axsl:when test="@type"/>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td> component unitdate
				 </td>
                                       <td>type=
					 </td>
                                       <td>Opt
				 </td>
                                       <td> Missing @type<axsl:call-template name="getcontext"/>
                                          <div class="appnotes" id="app.d0e1342">
                                             <h4>Application notes for  component unitdate</h4>
                                             <p>Used to distinquish inclusive and bulk dates.</p>
                                          </div>
                                          <br/>
                                          <a onclick="getAppNotes('app.d0e1342')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                       <td> 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@normal">
                                 <axsl:choose>
                                    <axsl:when test="@normal[(number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-after(substring-after(., '-'), '-')) &lt; 31) &#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '-')) &lt; 13 and number(substring-before(substring-after(substring-after(., '-'), '-'), '/')) &lt; 31 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000 and number(substring-before(substring-after(substring-after(., '/'), '-'), '-')) &lt; 13 and number(substring-after(substring-after(substring-after(., '/'), '-'), '-')) &lt; 31)&#xA;or (number(substring-before(., '-')) &lt; 3000 and number(substring-after(., '-')) &lt; 13)  or ( number(substring-before(., '-')) &lt; 3000 and number(substring-before(substring-after(., '-'), '/')) &lt; 13 and number(substring-before(substring-after(., '/'), '-')) &lt; 3000) or  (number() &lt; 3000) or ( number(substring-before(., '/')) &lt; 3000 and number(substring-after(., '/')) &lt; 3000)]"/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td> component unitdate
				 </td>
                                             <td>normal= </td>
                                             <td>Rec
				 </td>
                                             <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>
                                                <div class="appnotes" id="app.d0e1350">
                                                   <h4>Application notes for  component unitdate</h4>
                                                   <p>To aid in searching by date; use ISO 8601 (see the BPG
Introduction, page 3-4, for examples).</p>
                                                </div>
                                                <br/>
                                                <a onclick="getAppNotes('app.d0e1350')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                             <td>Use  "iso8601" to format the attribute value. 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td> component unitdate
				 </td>
                                       <td>normal=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @normal<axsl:call-template name="getcontext"/>
                                          <div class="appnotes" id="app.d0e1350">
                                             <h4>Application notes for  component unitdate</h4>
                                             <p>To aid in searching by date; use ISO 8601 (see the BPG
Introduction, page 3-4, for examples).</p>
                                          </div>
                                          <br/>
                                          <a onclick="getAppNotes('app.d0e1350')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                       <td> Use "iso8601" to format attribute value. 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.2.3'  or @encodinganalog='245$f'  or @encodinganalog='245$g'  or @encodinganalog='260$c'  or @encodinganalog='Coverage'  or @encodinganalog='Date' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td> component unitdate
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '245$f'  or  '245$g'  or  '260$c' .
 For DC 'Coverage'  or 'Date' . 
For ISAD(G)v2:'3.2.3'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td> component unitdate
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '245$f'  or  '245$g'  or  '260$c' .
 For DC 'Coverage'  or 'Date' . 
For ISAD(G)v2:'3.2.3'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td> component unitdate
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td> The repeatable element &lt; component unitdate
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1340">
                                 <h4>Application notes for  component unitdate</h4>
                                 <p>Recommended if a more specific creation date can be
provided for a component than given in its parent. Such
entries provide for fuller description of a unit for users and
facilitate more effective searching by date. If multiple single
dates or date ranges are present, each should be encoded
in its own &lt;unitdate&gt;. Where no &lt;unittitle&gt; content exists,
&lt;unitdate&gt; may be placed within &lt;unittitle&gt; so that there is
some title-related content. This element is considered an
essential element for data exchange by ISAD(G)v2.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1340')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdescdsc/did//physdesc/extent">
                        <axsl:for-each select="ead/archdescdsc/did//physdesc/extent">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.1.5'  or @encodinganalog='300' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>component physdesc/extent
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '300' .
For ISAD(G)v2:'3.1.5'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>component physdesc/extent
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '300' .
For ISAD(G)v2:'3.1.5'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>component physdesc/extent
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;component physdesc/extent
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1387">
                                    <h4>Application notes for component physdesc/extent</h4>
                                    <p>If extent data is present, it should be encoded here rather than being incorporated into &lt;unittitle&gt; or another element.  Units of measure should be epxressed either as part of the content of this tag or in a unit attribute. This element is considered an essential element for data exchange by ISAD(G)v2.</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e1387')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/dsc//phystech">
                        <axsl:for-each select="ead/archdesc/dsc//phystech">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.4.4'  or @encodinganalog='340'  or @encodinganalog='538' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>component phystech
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '340'  or  '538' .
For ISAD(G)v2:'3.4.4'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>component phystech
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '340'  or  '538' .
For ISAD(G)v2:'3.4.4'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>component phystech
				 </td>
                              <td> </td>
                              <td>Opt
				 </td>
                              <td> The repeatable element &lt;component phystech
&gt; not been used in this document.
							

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/dsc//did/langmaterial/language">
                        <axsl:for-each select="ead/archdesc/dsc//did/langmaterial/language">
                           <axsl:choose>
                              <axsl:when test="@langcode">
                                 <axsl:choose>
                                    <axsl:when test="@langcode[string-length()='3']"/>
                                    <axsl:otherwise>
                                       <tr>
                                          <td>component langmaterial/lanuage
				 </td>
                                          <td>langcode= </td>
                                          <td>M
				 </td>
                                          <td>This attribute is not formated correctly <axsl:call-template name="getcontext"/>
                                             <div class="appnotes" id="app.d0e1425">
                                                <h4>Application notes for component langmaterial/lanuage</h4>
                                                <p>Use ISO 639-2.</p>
                                             </div>
                                             <br/>
                                             <a onclick="getAppNotes('app.d0e1425')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                          <td>Use  "iso639-2b" to format the attribute value.
				 </td>
                                       </tr>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>component langmaterial/lanuage
				 </td>
                                    <td>langcode=
					 </td>
                                    <td>M
				 </td>
                                    <td> Missing @langcode<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e1425">
                                          <h4>Application notes for component langmaterial/lanuage</h4>
                                          <p>Use ISO 639-2.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1425')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td> Use "iso639-2b" to format attribute value.
				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>component langmaterial/lanuage
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td> The repeatable element &lt;component langmaterial/lanuage
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1423">
                                 <h4>Application notes for component langmaterial/lanuage</h4>
                                 <p>If the material being described is in a language different from that specified in the langmaterial attribute in &lt;archdesc&gt;, use at the componet level.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1423')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc//scopecontent[not(ancestor::dsc)]">
                        <axsl:for-each select="ead/archdesc//scopecontent[not(ancestor::dsc)]">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.3.1'  or @encodinganalog='520'  or @encodinganalog='Description' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>ead/archdesc//scopecontent
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '520' .
 For DC 'Description' . 
For ISAD(G)v2:'3.3.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>ead/archdesc//scopecontent
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '520' .
 For DC 'Description' . 
For ISAD(G)v2:'3.3.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>ead/archdesc//scopecontent
				 </td>
                           <td> </td>
                           <td>M
				 </td>
                           <td>The element &lt; ead/archdesc//scopecontent
&gt; does not appear in this document.<div class="appnotes" id="app.d0e1438">
                                 <h4>Application notes for ead/archdesc//scopecontent</h4>
                                 <p> At appropriate component levels(subgroup/subfonds,series) components should include scope and content information. Other levels may include scope and content notes as needed. Use of &lt;scopecontent&gt; is preferred over &lt;abstract&gt;.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1438')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/dsc//userestrict">
                        <axsl:for-each select="ead/archdesc/dsc//userestrict">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.4.2'  or @encodinganalog='540' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>component userestrict
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '540' .
For ISAD(G)v2:'3.4.2'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>component userestrict
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '540' .
For ISAD(G)v2:'3.4.2'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>component userestrict
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td> The repeatable element &lt;component userestrict
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1459">
                                 <h4>Application notes for component userestrict</h4>
                                 <p>Mandatory if there are particular conditions, such as copyright, governing use. </p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1459')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="ead/archdesc/dsc//accessrestrict">
                        <axsl:for-each select="ead/archdesc/dsc//accessrestrict">
                           <axsl:choose>
                              <axsl:when test="@encodinganalog">
                                 <axsl:choose>
                                    <axsl:when test="@encodinganalog='3.4.1'  or @encodinganalog='506' "/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>component accessrestrict
				 </td>
                                             <td>encodinganalog=
									 </td>
                                             <td>Rec
				 </td>
                                             <td>The current value is not correct. 
<axsl:call-template name="getcontext"/>

				 </td>
                                             <td> For MARC21: '506' .
For ISAD(G)v2:'3.4.1'  
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>component accessrestrict
				 </td>
                                       <td>encodinganalog=
					 </td>
                                       <td>Rec
				 </td>
                                       <td> Missing @encodinganalog<axsl:call-template name="getcontext"/>

				 </td>
                                       <td> For MARC21: '506' .
For ISAD(G)v2:'3.4.1'  
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <tr>
                           <td>component accessrestrict
				 </td>
                           <td> </td>
                           <td>MA
				 </td>
                           <td> The repeatable element &lt;component accessrestrict
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1477">
                                 <h4>Application notes for component accessrestrict</h4>
                                 <p>Mandatory if particular conditions govern access.</p>
                              </div>
                              <br/>
                              <a onclick="getAppNotes('app.d0e1477')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                           <td>
				 </td>
                        </tr>
                     </axsl:otherwise>
                  </axsl:choose>
               </tbody>
            </table>
	
            <h2>Item Level, Linking</h2>
            <table border="1" width="100%" rules="all">
               <tbody>
                  <tr>
                     <th width="20%">Element Location</th>
                     <th width="15%">Attributes or Child Elements</th>
                     <th width="5%">Status</th>
                     <th width="40%">Application Notes</th>
                     <th width="20%">Possible Values</th>
                  </tr>
                  <axsl:choose>
                     <axsl:when test="//daogrp">
                        <axsl:for-each select="//daogrp">
                           <axsl:choose>
                              <axsl:when test="../unittitle|../unitid"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>item level daogrp
				 </td>
                                    <td>
&lt;../unittitle&gt;
 or 
&lt;../unitid&gt;
 </td>
                                    <td>M
				 </td>
                                    <td>At least one should be supplied. 

<div class="appnotes" id="app.d0e1503">
                                          <h4>Application notes for item level daogrp</h4>
                                          <p>One of &lt;did&gt;&lt;unittitle&gt; or &lt;did&gt;&lt;unitid&gt; is required if the other is not available when linking to digital archive content.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1503')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>
&lt;../unittitle&gt;
 or 
&lt;../unitid&gt;

				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="../../@level='item'"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>item level daogrp
				 </td>
                                    <td>
&lt;../../@level='item'&gt;
 </td>
                                    <td>M
				 </td>
                                    <td>All  must be supplied. 


<div class="appnotes" id="app.d0e1515">
                                          <h4>Application notes for item level daogrp</h4>
                                          <p> The level attribute of the &lt;c&gt;/ &lt;c0x&gt; should be set to 'item'  when linking to digital archive content .</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1515')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>
&lt;../../@level='item'&gt;

				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="daoloc"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <tr>
                                    <td>item level daogrp
				 </td>
                                    <td>
&lt;daoloc&gt;
 </td>
                                    <td>Req
				 </td>
                                    <td>All child elements must be supplied. 


<axsl:call-template name="getcontext"/>
                                       <div class="appnotes" id="app.d0e1524">
                                          <h4>Application notes for item level daogrp</h4>
                                          <p>&lt;daoloc&gt; is required in &lt;daogrp&gt;.</p>
                                       </div>
                                       <br/>
                                       <a onclick="getAppNotes('app.d0e1524')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                    <td>
&lt;daoloc&gt;

				 </td>
                                 </tr>
                              </axsl:otherwise>
                           </axsl:choose>
                           <axsl:choose>
                              <axsl:when test="daodesc"><!--Remain silent No error--></axsl:when>
                              <axsl:otherwise>
                                 <axsl:if test="$all='yes'">
                                    <tr>
                                       <td>item level daogrp
				 </td>
                                       <td>
&lt;daodesc&gt;
 </td>
                                       <td>Rec
				 </td>
                                       <td>Include these child elements as applicable. 
						
<axsl:call-template name="getcontext"/>
                                          <div class="appnotes" id="app.d0e1533">
                                             <h4>Application notes for item level daogrp</h4>
                                             <p>Use if human-readable description of complex digital object is required
and not provided by &lt;unittitle&gt;</p>
                                          </div>
                                          <br/>
                                          <a onclick="getAppNotes('app.d0e1533')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                       <td>
&lt;daodesc&gt;
 
				</td>
                                    </tr>
                                 </axsl:if>
                              </axsl:otherwise>
                           </axsl:choose>
                        </axsl:for-each>
                     </axsl:when>
                     <axsl:otherwise>
                        <axsl:if test="$all='yes'">
                           <tr>
                              <td>item level daogrp
				 </td>
                              <td> </td>
                              <td>Rec
				 </td>
                              <td> The repeatable element &lt;item level daogrp
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1501">
                                    <h4>Application notes for item level daogrp</h4>
                                    <p>Required for linking to digital archival objects (see "Digital Objects and
Linking Elements,” page 4).</p>
                                 </div>
                                 <br/>
                                 <a onclick="getAppNotes('app.d0e1501')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                              <td> 
				</td>
                           </tr>
                        </axsl:if>
                     </axsl:otherwise>
                  </axsl:choose>
                  <axsl:choose>
                     <axsl:when test="//daogrp">
                        <axsl:choose>
                           <axsl:when test="//daoloc">
                              <axsl:for-each select="//daoloc">
                                 <axsl:choose>
                                    <axsl:when test="@entityref or @href"/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>item level daoloc
				 </td>
                                             <td> </td>
                                             <td>Rec
				 </td>
                                             <td>You must supply at least one of the attributes: entityref or href<div class="appnotes" id="app.d0e1548">
                                                   <h4>Application notes for item level daoloc</h4>
                                                   <p>Use of either entityref or href is mandatory. Use to link to an entity that contains the
actual link to an external digital object. Xlink and xpointer are not
commonly used.</p>
                                                </div>
                                                <br/>
                                                <a onclick="getAppNotes('app.d0e1548')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                             <td>n/a 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                                 <axsl:choose>
                                    <axsl:when test="@role"/>
                                    <axsl:otherwise>
                                       <axsl:if test="$all='yes'">
                                          <tr>
                                             <td>item level daoloc
				 </td>
                                             <td>role=
					 </td>
                                             <td>Rec
				 </td>
                                             <td> Missing @role<axsl:call-template name="getcontext"/>
                                                <div class="appnotes" id="app.d0e1564">
                                                   <h4>Application notes for item level daoloc</h4>
                                                   <p>Use to indicate the nature of the linked object (JPEG, XML, SGML,
video) by MIME type.</p>
                                                </div>
                                                <br/>
                                                <a onclick="getAppNotes('app.d0e1564')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                             <td> 
				</td>
                                          </tr>
                                       </axsl:if>
                                    </axsl:otherwise>
                                 </axsl:choose>
                              </axsl:for-each>
                           </axsl:when>
                           <axsl:otherwise>
                              <tr>
                                 <td>item level daoloc
				 </td>
                                 <td> </td>
                                 <td>Req
				 </td>
                                 <td> The repeatable element &lt;item level daoloc
&gt; not been used in this document.
							<div class="appnotes" id="app.d0e1546">
                                       <h4>Application notes for item level daoloc</h4>
                                       <p>Required for linking to digital archival objects (see "Digital Objects and
Linking Elements,” page 4).</p>
                                    </div>
                                    <br/>
                                    <a onclick="getAppNotes('app.d0e1546')" style="color:green;text-decoration:underline;cursor:pointer;cursor:hand">View Application Notes</a>

				 </td>
                                 <td>
				 </td>
                              </tr>
                           </axsl:otherwise>
                        </axsl:choose>
                     </axsl:when>
                     <axsl:otherwise/>
                  </axsl:choose>
               </tbody>
            </table>

            <div>
               <axsl:attribute name="class">appnotes</axsl:attribute>
               <axsl:attribute name="id">source</axsl:attribute>
               <axsl:apply-templates mode="verb" select="."/>
            </div>
         </body>
      </html>
   </axsl:template>
   <axsl:template name="getcontext">
      <axsl:choose>
         <axsl:when test="name(..) ='ead'">
            <br/>
            <a>
               <axsl:attribute name="onclick">writeSource('<axsl:value-of select="generate-id()"/>')</axsl:attribute>
               <axsl:attribute name="style">color:red;text-decoration:underline;cursor:pointer;cursor:hand</axsl:attribute>View Context</a>
         </axsl:when>
         <axsl:when test="name()= 'did'">
            <br/>
            <a>
               <axsl:attribute name="onclick">writeSource('<axsl:value-of select="generate-id(..)"/>')</axsl:attribute>
               <axsl:attribute name="style">color:red;text-decoration:underline;cursor:pointer;cursor:hand</axsl:attribute>View Context</a>
         </axsl:when>
         <axsl:when test="name(..)= 'did'">
            <br/>
            <a>
               <axsl:attribute name="onclick">writeSource('<axsl:value-of select="generate-id(../..)"/>')</axsl:attribute>
               <axsl:attribute name="style">color:red;text-decoration:underline;cursor:pointer;cursor:hand</axsl:attribute>View Context</a>
         </axsl:when>
         <axsl:when test="name(../..) ='did'">
            <br/>
            <a>
               <axsl:attribute name="onclick">writeSource('<axsl:value-of select="generate-id(../../..)"/>')</axsl:attribute>
               <axsl:attribute name="style">color:red;text-decoration:underline;cursor:pointer;cursor:hand</axsl:attribute>View Context</a>
         </axsl:when>
         <axsl:when test="name(..) ='eadheader'">
            <br/>
            <a>
               <axsl:attribute name="onclick">writeSource('<axsl:value-of select="generate-id(..)"/>')</axsl:attribute>
               <axsl:attribute name="style">color:red;text-decoration:underline;cursor:pointer;cursor:hand</axsl:attribute>View Context</a>
         </axsl:when>
         <axsl:when test="name(../..) ='archdesc' and name(..)='did'">
            <br/>
            <a>
               <axsl:attribute name="onclick">writeSource('<axsl:value-of select="generate-id(..)"/>')</axsl:attribute>
               <axsl:attribute name="style">color:red;text-decoration:underline;cursor:pointer;cursor:hand</axsl:attribute>View Context</a>
         </axsl:when>
         <axsl:otherwise>
            <br/>
            <a>
               <axsl:attribute name="onclick">writeSource('<axsl:value-of select="generate-id(..)"/>')</axsl:attribute>
               <axsl:attribute name="style">color:red;text-decoration:underline;cursor:pointer;cursor:hand</axsl:attribute>View Context</a>
         </axsl:otherwise>
      </axsl:choose>
   </axsl:template>
   <axsl:template name="getStaticLink">
      <a>
         <axsl:attribute name="href">
            <axsl:value-of select="$sourcedoc"/>#<axsl:value-of select="generate-id()"/>
         </axsl:attribute>
         <axsl:attribute name="target">targetArea1</axsl:attribute>
View Context</a>
   </axsl:template>
</axsl:stylesheet>
